// fun with linked lists


interface LinkedListIntf {
    public void addAfter(Object data);
    public void deleteAfter();
    public LinkedListIntf nextLink();
}

class LinkedList implements LinkedListIntf {
    private LinkedList next;
    public Object datum;

    public LinkedListIntf nextLink() { return (LinkedListIntf) this.next; }
    public LinkedList next() { return (LinkedList) nextLink(); }

    public LinkedList(Object o) { 
       this.next=null; 
       this.datum=o; 
    }
     
    public void addAfter(Object o) { 
       LinkedList tmp = new LinkedList(o);
       tmp.next = this.next;
       this.next = tmp;
    }
      
    public void deleteAfter() {
       if (this.next!=null)
             this.next = this.next.next;
    }

}

// a crude driver program.  See if you can do a neater job.
class test5g {
  public static void main (String ar[]) {
      LinkedList l, root=new LinkedList((Object) (new Integer(-2)) );
      for (int i=0; i< 5; i++) {
          root.addAfter( new Integer(i) );
       //    System.out.println("Have added int " +i);
      }
      l= root;
      for (int i=0; i< 5; i++) {
           if (l.datum!=null)
              System.out.println(" read back " 
                  + ((Integer) l.datum).intValue() );
           l=l.next();
      }
      
      (root.next().next()).deleteAfter(); 
      (root.next().next()).addAfter((Object)(new Integer(77))); 

      l= root;
      for (int i=0; i< 5; i++) {
           if (l.datum!=null)
              System.out.println(" read back " 
                  + ((Integer) l.datum).intValue() );
           l=l.next();
      }
      

  }

}
