// shows the use of various input streams
import java.io.*;
public class test7b {
    static String s = new String( "aardvark butterfly\ncarp dalmatian\n" +
               "eagle fish\ngopher hippo\ninyala jackal\nkyloe " +
               "lamb\nmoose nanny-goat\nopossum puff-adder" );
 
    static StringBufferInputStream sbis = new StringBufferInputStream( s );

    static LineNumberInputStream lnis = new LineNumberInputStream( sbis );

    public static void main (String a[]) {
        int c;
        try {
            while ((c=lnis.read())!= -1) {

                System.out.print((char)c);
                if (c=='\n') {
                     System.out.print("that finishes input line " +
                             lnis.getLineNumber() + "\n\n");
                }
                  
            }
        } catch (IOException ioe) {
                System.out.println("Exception reading stream");
                ioe.printStackTrace();
                System.exit(0);
        }
    }
}
