// shows the use of various input streams
// this is the answer to the Programming Challenge
// Use SequenceInputStream to supply a FileInputStream 
// as well as the StringBufferInputStream that we are using above.   
// Create a file called animals.txt that contains a few more creatures.  

import java.io.*;
public class test7c {
    static String s=new String("aardvark butterfly\ncarp dalmatian\n" +
               "eagle fish\ngopher hippo\ninyala jackal\nkyloe " +
               "lamb\nmoose nanny-goat\nopossum puff-adder\n" );
 
    static StringBufferInputStream sbis=new StringBufferInputStream(s);

    public static void main (String a[]) throws FileNotFoundException {
        int c;
        FileInputStream fis = new FileInputStream("animals.txt");

        SequenceInputStream sis =
              new SequenceInputStream( sbis, fis );

        LineNumberInputStream lsis = new LineNumberInputStream( sis );

        try {
            while ((c=lsis.read())!= -1) {

                System.out.print((char)c);
                if (c=='\n') {
                     System.out.print("that finishes input line " +
                             lsis.getLineNumber() + "\n\n");
                }
                  
            }
        } catch (IOException ioe) {
                System.out.println("Exception reading stream");
                ioe.printStackTrace();
                System.exit(0);
        }
    }
}
