/**
 *  a network server that detects presence of dogs on the Internet
 *
 *  @version   1.1 Jan 21 1996
 *  @author    Peter van der Linden
 *  @author    From the book "Just Java"
 *
 *
 */
import java.io.*;
import java.net.*;

class server {
    public static void main(String a[]) throws IOException {
        int timeoutsecs = 600;
        int port = 4444;
        Socket sock;
        String query = "If you met me would you shake my hand, or sniff it?";

        ServerSocket servsock = new ServerSocket(port, timeoutsecs);

    while (true) {
        // wait for the next client connection
	sock=servsock.accept();

        // Get I/O streams from the socket
	PrintStream out = new PrintStream( sock.getOutputStream() );
	DataInputStream in  = new DataInputStream( sock.getInputStream() );

        // Send our query
        out.println(query);
        out.flush();

        // get the reply
        String reply = in.readLine();
        if (reply.indexOf("sniff") > -1) 
             System.out.println("On the Internet I know this is a DOG!");
        else System.out.println("Probably a person or an AI experiment");

	// Close this connection, (not the overall server socket)
	sock.close();
     }
  }
}
