// an example of polymorphism.
// at runtime, the program needs to determine whether it
// has an ordinary fruit, or a citrus fruit, and call the
// corresponding method peel()

// BTW, this funny indenting is what you get if you run "indent"
// on a Java source file under Unix.

class Fruit {
		private int     grams;
		private int     cals_per_gram;

		int             total_calories() {
			return grams * cals_per_gram;
		}
		void            peel() {
			System.out.println("peel a Fruit");
		}
};

class Citrus extends Fruit {
		void            squeeze() {	/* ... */ }
		void            peel() {
			System.out.println("peel a Citrus");
		}
}

class test2e {
		public static void main(String args[]) {
			Fruit           somefruit = new Fruit();
			Citrus          lemon = new Citrus();

			                somefruit.peel();
			                lemon.peel();

			                somefruit = lemon;
			                somefruit.peel();
		}
}
